SoFaceSet(3)

NAME
SoFaceSet - The SoFaceSet class is used to render and organize non-indexed polygonal face data.

SYNOPSIS

#include <Inventor/nodes/SoFaceSet.h>

Inherits SoNonIndexedShape.

  Public Member Functions
virtual SoType getTypeId (void) const
SoFaceSet (void)
virtual void GLRender (SoGLRenderAction *action)
virtual SbBool generateDefaultNormals (SoState *state, SoNormalBundle *nb)
virtual void getPrimitiveCount (SoGetPrimitiveCountAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)

  Public Attributes
SoMFInt32 numVertices

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoFaceSet ()
virtual void generatePrimitives (SoAction *action)
virtual void computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)
virtual SbBool generateDefaultNormals (SoState *, SoNormalCache *)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoFaceSet class is used to render and organize non-indexed polygonal face data. Facesets are specified using the numVertices field. Coordinates, normals, materials and texture coordinates are fetched in order from the current state or from the vertexProperty node if set. For example, if numVertices is set to [3, 4, 5, 3], this node would specify a triangle from coordinates 0, 1 and 2, a quad from coordinates 3, 4, 5 and 6, a polygon from coordinates 7, 8, 9, 10 and 11 and finally a triangle from coordinates 12, 13, 14.

Binding PER_VERTEX, PER_FACE or OVERALL can be set for material, and normals. The default material binding is OVERALL. The default normal binding is PER_VERTEX.

For more elaborate documentation about face sets, see the class documentation of the SoIndexedFaceSet node, which contains examples and more detailed information about various issues also relevant for this node.

FILE FORMAT/DEFAULTS:

FaceSet {
    vertexProperty NULL
    startIndex 0
    numVertices -1
}

See also
    SoIndexedFaceSet, SoIndexedTriangleStripSet

Constructor & Destructor Documentation

  SoFaceSet::SoFaceSet (void)
Constructor.

  SoFaceSet::~SoFaceSet () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoFaceSet::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoFaceSet::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoNonIndexedShape.

  const SoFieldData ** SoFaceSet::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoFaceSet::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoNonIndexedShape.

  void SoFaceSet::initClass (void) [static]

  void SoFaceSet::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoShape.

  SbBool SoFaceSet::generateDefaultNormals (SoState * state, SoNormalBundle * bundle) [virtual]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Subclasses should override this method to generate default normals using the SoNormalBundle class. TRUE should be returned if normals were generated, FALSE otherwise.

Default method returns FALSE.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Reimplemented from SoVertexShape.

  void SoFaceSet::getPrimitiveCount (SoGetPrimitiveCountAction * action) [virtual]
Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoShape.

  void SoFaceSet::generatePrimitives (SoAction * action) [protected], [virtual]
The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().)

The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller.

Implements SoShape.

  void SoFaceSet::computeBBox (SoAction * action, SbBox3f & box, SbVec3f & center) [protected], [virtual]
Implemented by SoShape subclasses to let the SoShape superclass know the exact size and weighted center point of the shape's bounding box.

The bounding box and center point should be calculated and returned in the local coordinate system.

The method implements action behavior for shape nodes for SoGetBoundingBoxAction. It is invoked from SoShape::getBoundingBox(). (Subclasses should not override SoNode::getBoundingBox().)

The box parameter sent in is guaranteed to be an empty box, while center is undefined upon function entry.

Implements SoShape.

  SbBool SoFaceSet::generateDefaultNormals (SoState * state, SoNormalCache * cache) [protected], [virtual]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Subclasses should override this method to generate default normals using the SoNormalCache class. This is more effective than using SoNormalGenerator. Return TRUE if normals were generated, FALSE otherwise.

Default method just returns FALSE.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Reimplemented from SoVertexShape.

Member Data Documentation

  SoMFInt32 SoFaceSet::numVertices
Used to specify faces. Each entry specifies the number of coordinates in a face. The coordinates are taken in order from the state or from the vertexProperty node.

Author

Generated automatically by Doxygen for Coin from the source code.